"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ACION_NAMESPACE = '[@@Normalize]';
var NormalizeActionTypes = (function () {
    function NormalizeActionTypes() {
    }
    NormalizeActionTypes.SET_DATA = ACION_NAMESPACE + " Set Data";
    NormalizeActionTypes.ADD_DATA = ACION_NAMESPACE + " Add Data";
    NormalizeActionTypes.REMOVE_DATA = ACION_NAMESPACE + " Remove Data";
    return NormalizeActionTypes;
}());
exports.NormalizeActionTypes = NormalizeActionTypes;
var SetData = (function () {
    function SetData(payload) {
        this.payload = payload;
        this.type = NormalizeActionTypes.SET_DATA;
    }
    return SetData;
}());
exports.SetData = SetData;
var AddData = (function () {
    function AddData(payload) {
        this.payload = payload;
        this.type = NormalizeActionTypes.ADD_DATA;
    }
    return AddData;
}());
exports.AddData = AddData;
var RemoveData = (function () {
    function RemoveData(payload) {
        this.payload = payload;
        this.type = NormalizeActionTypes.REMOVE_DATA;
    }
    return RemoveData;
}());
exports.RemoveData = RemoveData;
function actionCreators(schema) {
    return {
        setData: function (data) {
            return new SetData({ data: data, schema: schema });
        },
        addData: function (data) {
            return new AddData({ data: data, schema: schema });
        },
        removeData: function (id, removeChildren) { return new RemoveData({ id: id, schema: schema, removeChildren: removeChildren }); }
    };
}
exports.actionCreators = actionCreators;
